=== doc/requirements.txt ===

- The UNIX version requires snprintf().
