=== unix/tx/CMakeLists.txt ===
include_directories(${X11_INCLUDE_DIR})

include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/common/rfb)

add_library(tx STATIC
  TXWindow.cxx
  TXScrollbar.cxx
  TXViewport.cxx
  TXImage.cxx
  TXMenu.cxx)

target_link_libraries(tx ${X11_LIBRARIES})
